<?php

/**
 * Plugin Name: 【Catch the Plugin】LPtools
 * Plugin URI:
 * Description:
 * Version: 1.6.4
 * Author: Catch the Web
 * Requires at least: 5.8
 * 
 * @package catch_the_lptools
 */

defined( 'ABSPATH' ) || exit;

function get_lptools_plugin_path(){
	return plugin_dir_path(__FILE__);
}

function get_lptools_plugin_url(){
	return plugin_dir_url(__FILE__);
}

// --------------------------------------------
// 定数
// --------------------------------------------
define( 'CTW_LPTOOLS_TEMPLATE_SLUG', '../template/lptools_lp.php' );

// --------------------------------------------
// アップデート通知
// --------------------------------------------
require 'update-check/plugin-update-checker.php'; // 「Plugin Update Checker」をインクルード
$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
'https://ctw-contents.com/lptools/plugin-update/catch_the_lptools_update.json', // 作成したJSONファイルの
__FILE__, // プラグインのメインファイル、もしくはテーマ内のファイル「functions.php」のフルパス
'catch_the_lptools' // プラグインもしくはテーマのスラッグ
);

// --------------------------------------------
// ファンクション
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/functions.php';

// --------------------------------------------
// オプション設定
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/admin.php';

// --------------------------------------------
// カスタム投稿
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/custom_post.php';

// --------------------------------------------
// ブロック関連
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/block.php';

// --------------------------------------------
// パターン登録
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/block_pattern.php';

// --------------------------------------------
// 固定ページテンプレート登録
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/page_template.php';

// --------------------------------------------
// ブロックパターンギャラリー
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/lptools_templates.php';

// --------------------------------------------
// テンプレートエクスポート
// --------------------------------------------
require_once get_lptools_plugin_path().'lib/export_template.php';

// --------------------------------------------
// バージョンチェック
// --------------------------------------------
function ctw_lptools_check_wp_ver() {
	if( version_compare(get_bloginfo('version'),'5.8', '>=') ) {
		return true;
	} else {
		return false;
	}
}

function lptools_admin_notices() {
	?>
	<style type="text/css" media="screen">
		.lptools-news {
			margin-top: 1.5em;
			margin-right: 20px;
		}
		.lptools-news-headline {
			margin-bottom: 0;
			padding: 5px .75em;
			display: inline-block;
			background: #d9261c;
			font-weight: bold;
			color: #fff;
		}
		.lptools-news-content {
			padding: .75em;
			background: #ffffff;
			border: 1px solid #d9261c;
			color: #d9261c;
			line-height: 1.5;
		}
	</style>
	<div class="lptools-news">
		<div class="lptools-news-headline">LPtoolsからのお知らせ</div>
		<div class="lptools-news-content">
			<?php echo 'LPtoolsはWordPressバージョン5.8以降が必要です。現在のバージョン：'.get_bloginfo('version'); ?></div>
	</div>
	<?php
}
if( !ctw_lptools_check_wp_ver() ) {
	add_action( 'admin_notices', 'lptools_admin_notices' );
}

// --------------------------------------------
// CSS調整
// --------------------------------------------
function ctw_lptools_enqueue_styles() {
	global $post_type;
	global $post;
	if( isset($post->ID) ) { $slug = get_page_template_slug( $post->ID ); }
	
	if( ( 'clp' == $post_type || 'lptools_template' == $post_type || ( 'page' == $post_type && $slug == CTW_LPTOOLS_TEMPLATE_SLUG ) ) && get_option('lptools_use_other_blocks') != 1 ) {
		wp_dequeue_style( 'theme-editor-style' );			// アルバトロス
		wp_dequeue_style( 'cocoon-gutenberg' );				// Coccoon
		wp_dequeue_style( 'cocoon_blocks-cgb-style-css' );	// Coccoon
		wp_dequeue_style( 'cocoon_blocks-cgb-block-editor-css' );	// Coccoon
		wp_dequeue_style( 'cocoon-css-cache-style' );		// Coccoon
		wp_dequeue_style( 'cocoon-gutenberg-content' );		// Coccoon
		wp_dequeue_style( 'st-block-editor-style' );		// AFFINGER
		wp_dequeue_style( 'keni_block-cgb-style-css' );			// 権威8.0
		wp_dequeue_style( 'keni_block-cgb-block-editor-css' );	// 権威8.0
		wp_dequeue_style( 'keni-advanced-css' );				// 権威8.0
		wp_dequeue_style( 'acf-global' );					// Colorful
		wp_dequeue_style( 'acf-input' );					// Colorful
		wp_dequeue_style( 'select2' );						// Colorful
		wp_dequeue_style( 'acf-datepicker' );				// Colorful
		wp_dequeue_style( 'acf-timepicker' );				// Colorful
		wp_dequeue_style( 'my_admin_style' );				// Colorful
		wp_dequeue_style( 'myOptionsCSS' );					// Colorful
	}
}
add_action( 'admin_print_styles-post.php', 'ctw_lptools_enqueue_styles', 9999 );
add_action( 'admin_print_styles-post-new.php', 'ctw_lptools_enqueue_styles', 9999 );

// --------------------------------------------
// カスタム投稿clpで特定ブロック削除＆LPtoolsテンプレート以外ではLPtoolsブロック削除
// --------------------------------------------
function ctw_lptools_dequeue_script() {
	global $post_type;
	global $post;
	if( isset($post->ID) ) { $slug = get_page_template_slug( $post->ID ); }
	
	if( ( 'clp' == $post_type || 'lptools_template' == $post_type || ( 'page' == $post_type && $slug == CTW_LPTOOLS_TEMPLATE_SLUG ) ) && get_option('lptools_use_other_blocks') != 1 ) {
		wp_dequeue_script( 'cocoon-blocks-js' );	// Cocoon
	}

	if( ('clp' != $post_type && 'lptools_template' != $post_type) && $slug != CTW_LPTOOLS_TEMPLATE_SLUG ) {
		wp_dequeue_script( 'ctw-lptools' );	// LPtools
	}
}
add_action( 'admin_print_styles-post.php', 'ctw_lptools_dequeue_script', 9999 );
add_action( 'admin_print_styles-post-new.php', 'ctw_lptools_dequeue_script', 9999 );

// --------------------------------------------
// フッターで読み込み
// --------------------------------------------
function lptools_custom_admin_footer() {
	global $post_type;
	global $post;
	$slug = '';
	
	if( isset($post->ID) ) { $slug = get_page_template_slug( $post->ID ); }	
	if( 'clp' == $post_type || 'lptools_template' == $post_type || ( 'page' == $post_type && $slug == CTW_LPTOOLS_TEMPLATE_SLUG ) ) {
		wp_enqueue_style( 'ctw-lptools' );
		wp_enqueue_style( 'ctw-lptools-editor' );
	}
}
add_action('admin_print_styles', 'lptools_custom_admin_footer');

// --------------------------------------------
// テンプレートを1つずつエクスポート
// --------------------------------------------
function lptools_add_lptools_template_posts_columns($columns) {
    $columns[ 'lptools_template_export' ] = '';

    return $columns;
}
function lptools_add_lptools_template_posts_columns_row( $column_name, $post_id ) {
    if ( $column_name == 'lptools_template_export' ) {
        echo '<a href="' . admin_url( '/export.php' ) . "?download=1&content=lptools_template&export-media-with-selected-content=1&id={$post_id}" . '" class="button button-primary" >このLPをエクスポート</a>';
    }
}
add_filter( 'manage_lptools_template_posts_columns', 'lptools_add_lptools_template_posts_columns' );
add_action( 'manage_lptools_template_posts_custom_column', 'lptools_add_lptools_template_posts_columns_row', 10, 2 );
