<?php
if(!defined('ABSPATH')) exit;

// --------------------------------------------
// 全体設定ページを追加
// --------------------------------------------
add_action( 'admin_menu', 'ctwlpt_add_setting_page' );
function ctwlpt_add_setting_page() {
	add_menu_page('LPtools全体設定', 'LPtools全体設定', 'manage_options' , 'ctwlpt_option_menu', 'ctwlpt_options_page','dashicons-admin-generic',3);
	add_action( 'admin_init', function(){
		register_setting( 'ctwlpt-settings-group', 'lptools_use_post' );
		register_setting( 'ctwlpt-settings-group', 'lptools_use_other_blocks' );
		register_setting( 'ctwlpt-settings-group', 'lptools_code_add_end_head' );
		register_setting( 'ctwlpt-settings-group', 'lptools_code_add_end_body' );
		register_setting( 'ctwlpt-settings-group', 'lptools_color_palette_titles' );
		register_setting( 'ctwlpt-settings-group', 'lptools_color_palettes' );
		register_setting( 'ctwlpt-settings-group', 'lptools_code_add_code_edit' );
	} );

	add_submenu_page( 'ctwlpt_option_menu', '色設定', '色設定', 'manage_options', 'ctwlpt_option_menu_color', 'ctwlpt_options_page_color', 1 );
}

function ctwlpt_options_page() {
?>
<h1>LPtools 全体設定</h1>
<?php settings_errors(); ?>
<div class="admin_optional">
	<form method="post" action="options.php">
		<?php settings_fields( 'ctwlpt-settings-group' ); ?>
		<?php do_settings_sections( 'ctwlpt-settings-group' ); ?>
		<table class="form-table" role="presentation">
<!--
			<tr>
				<th scope="row">LPtoolsの利用範囲</th>
				<td>
					<fieldset>
						<legend class="screen-reader-text"><span>LPtoolsの利用範囲</span></legend><label for="lptools_use_post"><input name="lptools_use_post" type="checkbox" id="lptools_use_post" value="1" <?php checked(get_option('lptools_use_post'),'1') ?>>通常の投稿や固定ページでもLPtoolsのブロックを表示する</label>
					</fieldset>
					<div style="padding:1em;margin-top:1em;border:1px solid #ff263e;color:#ff263e">テーマのブロックやJavaScriptと競合する可能性がございますので、表示が崩れたり、正しく機能しない場合もございます。ご了承ください。<br />またタイマーブロックは投稿や固定ページでは利用できません。</div>
				</td>
			</tr>
-->
			<tr>
				<th>LPtools以外のブロックについて</th>
				<td>
					<label for="lptools_use_other_blocks"><input name="lptools_use_other_blocks" type="checkbox" id="lptools_use_other_blocks" value="1" <?php checked(get_option('lptools_use_other_blocks'),1) ?>>LPを作るとき、LPtools以外のブロックも表示する</label>
					<div style="padding:1em;margin-top:1em;border:1px solid #ff263e;color:#ff263e;max-width:640px;line-height:1.75;">テーマ独自のブロックを利用する場合にチェックを入れてください。その場合は、編集画面にある「【LPtools】オプション設定」より、wp_headかwp_footerのいずれか、または両方を読み込むようにしてください。<br />また、Cocoonをご利用の場合、LPtoolsのツールバーが利用できなくなりますのでご注意ください。</div>
				</td>
			</tr>
			<tr>
				<th>
					<p>一括コード追加（すべてのLPの &lt;/head&gt;前に出力されます）</p>
					<div style="font-size:.75em;font-weight:normal;color:#aaa">※編集画面には出力されません</div>
				</th>
				<td>
					<p><textarea name="lptools_code_add_end_head" id="lptools_code_add_end_head" cols="100" rows="10" style="padding:.5em;"><?php echo get_option('lptools_code_add_end_head'); ?></textarea></p>
				</td>
			</tr>
			<tr>
				<th>
					<p>一括コード追加（すべてのLPの &lt;/body&gt;前に出力されます）</p>
					<div style="font-size:.75em;font-weight:normal;color:#aaa">※編集画面には出力されません</div>
				</th>
				<td>
					<p><textarea name="lptools_code_add_end_body" id="lptools_code_add_end_body" cols="100" rows="10" style="padding:.5em;"><?php echo get_option('lptools_code_add_end_body'); ?></textarea></p>
				</td>
			</tr>
		</table>
		<?php submit_button(); ?>
	</form>
</div>
<?php
}

// --------------------------------------------
// 色設定ページを追加
// --------------------------------------------
// add_action( 'admin_enqueue_scripts', function() { wp_enqueue_style( 'wp-color-picker' ); } );

function ctwlpt_options_page_color() {
	
	$ctwlpt_color_titles_default = ctwlpt_color_titles_default();	
	$ctwlpt_color_titles	= get_option( "lptools_color_palette_titles" );
	
	$ctwlpt_colors_default	= ctwlpt_colors_default();
	$ctwlpt_color_palettes	= get_option( "lptools_color_palettes" );

?>
<script>
jQuery(function($){
	$('.color-picker').wpColorPicker();
});
</script>
<h1>カスタムカラーパレット（色設定）</h1>
<?php settings_errors(); ?>
<div class="admin_optional">
	<form method="post" action="options.php">
		<?php settings_fields( 'ctwlpt-settings-group' ); ?>
		<?php do_settings_sections( 'ctwlpt-settings-group' ); ?>
<!-- 		<h2 class="title">カスタムカラーパレット</h2> -->
		<p>カラーパレット名とパレットで使う色を選択してください。カラーパレットは10個まで設定できます。</p>
		<p>空欄にして保存すると、LPtoolsが用意したデフォルトの設定が入力されます。<br />デフォルト設定に戻したい場合は空欄にして保存してください。</p>
		<table class="form-table" role="presentation">
			<?php for ( $i = 0; $i < 10; $i++ ) : ?>
			<?php
				// タイトル
				if( empty($ctwlpt_color_titles[$i]) ) {
					$ctwlpt_color_titles[$i] = $ctwlpt_color_titles_default[$i];
				}
				
				// 色の設定が何もないときはデフォを入れる
				if( empty($ctwlpt_color_palettes[$i]) ) {
					$ctwlpt_color_palettes[$i] = array();
				}
				
				if( count(array_filter($ctwlpt_color_palettes[$i])) == 0 ) {
					$ctwlpt_color_palettes[$i] = $ctwlpt_colors_default[$i];
				}
			?>
			<tr>
				<th>
					<p><input type="text" class="" name="lptools_color_palette_titles[]" value="<?php echo $ctwlpt_color_titles[$i]; ?>" placeholder="カラーパレット<?php echo $i + 1; ?>" /></p>
				</th>
				<td style="padding-bottom:2em;">
					<p>
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][0]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][1]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][2]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][3]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][4]; ?>" />
					</p>
					<p>
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][5]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][6]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][7]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][8]; ?>" />
						<input type="text" class="color-picker" name="lptools_color_palettes[<?php echo $i; ?>][]" value="<?php echo $ctwlpt_color_palettes[$i][9]; ?>" />
					</p>
				</td>
			</tr>
			<?php endfor; ?>
		</table>
		<?php submit_button(); ?>
	</form>
</div>
<?php
}

