<?php
class lptoolsExportTemplate {
	protected static $export_query_run = false;
	protected static $args = array();

	public function __construct() {
		add_filter( 'export_args', array($this, 'export_args'), 10, 1 );

		add_action( 'export_wp', array($this, 'export_wp'), 10, 1 );

		// custom export_query
		add_filter( 'export_query', array($this, 'add_id_to_export_query'), 10, 1 );
	}

	/**
	 * Filter export arguments, only when an actual export is requested (`$_GET['download']` is set)
	 */
	public function export_args( $args ) {
		if ( isset($_GET['id']) ) {
			$args['id'] = (int) $_GET['id'];
		}
		return $args;
	}

	/**
	 * Add `export_query` filter
	 */
	public function export_wp( $args ) {
		self::$args = $args;

		/**
		 * The `export_query` filter only alters the main export query. It requires the query to be a sql string starting with 'SELECT ID FROM {$wpdb->posts} '
		 */
		add_filter( 'query', array($this, 'export_query_filter'), 10, 1 );
	}

	public function export_query_filter( $query ) {
		global $wpdb;
		if (
			false === self::$export_query_run
			&& is_string($query)
			&& 0 === strpos( $query, "SELECT ID FROM {$wpdb->posts} " )
		) {
			remove_filter( 'query', array($this, 'export_query_filter'), 10 );
			self::$export_query_run = true;

			$query = apply_filters( 'export_query', $query );
		}
		return $query;
	}

	public function add_id_to_export_query( $query ) {
		global $wpdb;

		if ( isset( self::$args['content'], self::$args['id'] ) && 'all' !== self::$args['content'] && 'attachment' !== self::$args['content'] && self::$args['id'] ) {
			$query .= sprintf( " AND wp_posts.ID = %s", self::$args['id'] );
		}
		return $query;
	}
}
$lptoolsExportTemplate = new lptoolsExportTemplate();
