<?php
function ctw_lptools_gutenberg_style_custom() {
	wp_enqueue_style( 'ctw-lptools-style', get_lptools_plugin_url() . 'css/lptools_templates.css' );
	wp_enqueue_script( 'ctw-lptools-plugin', get_lptools_plugin_url() . 'lib/lptools_templates/plugins.js', [ 'wp-blocks', 'wp-i18n', 'wp-element', 'wp-editor', 'wp-plugins', 'wp-edit-post', 'wp-components' ] );
	wp_localize_script( 'ctw-lptools-plugin', 'ctw_lptools_imgurl', [ get_lptools_plugin_url() . 'img/lptools_templates/' ] );
}
add_action( 'enqueue_block_editor_assets', 'ctw_lptools_gutenberg_style_custom' );

// --------------------------------------------
// ブロックパターン モーダル
// --------------------------------------------
function ctw_lptools_admin_footer() {
	require	'lptools_templates/template.php';
	global $pagenow;
	if ( is_admin() && ( $pagenow == 'post.php' || $pagenow == 'post-new.php' ) ) {
?>
<div id="ctw_lptools_modal" class="ctw_lptools_modal" style="display:none;">
    <div class="ctw_lptools_modal_gallery">
	    <div id="ctw_lptools_buttons" class="ctw_lptools_buttons">
			<h1 class="ctw_lptools_modal_gallery_head"><img src="<?php echo get_lptools_plugin_url(); ?>img/logo_lptools_noreflection_small.png" width="100" alt="" /> LPテンプレート一覧<small style="font-size:.75em">（クリックで追加）</small></h1>
			<a id="ctw_lptools_close" onclick="LPtoolsTemplatesClose()" class="ctw_lptools_close_button"><svg width="24" height="24" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" aria-hidden="true" focusable="false"><path d="M12 13.06l3.712 3.713 1.061-1.06L13.061 12l3.712-3.712-1.06-1.06L12 10.938 8.288 7.227l-1.061 1.06L10.939 12l-3.712 3.712 1.06 1.061L12 13.061z"></path></svg></a>
		</div>
		<div class="ctw_lptools_modal_gallery_inner">
	        <?php
		        // My Templates
		        $args = array(
		            'post_type'			=> array( 'lptools_template' ),
		            'post_status'		=> array( 'publish' ),
		            'posts_per_page'	=> -1,
		            'order'				=> 'DESC',
		        );
		        $the_query = new WP_Query( $args );
		        
		        if ( $the_query->have_posts() ) {
		            $i = 0;
		            echo '<script>var LPtoolsMyTemplates = []; LPtoolsMyTemplates[0] = [\'マイテンプレート\', \'「テンプレートを作る」で作成した独自のテンプレート。\']; LPtoolsMyTemplates[1] = [];</script>';
		            while ( $the_query->have_posts() ) {
		                $j = $i + 1;
		                $the_query->the_post();
		                $pattern_title = get_the_title();
		                if( !$pattern_title ){
		                    $pattern_title = 'タイトルなし';
		                }
		                $pattern_content = get_the_content();
		                if( has_post_thumbnail() ) {
		                    $thumbnail_id = get_post_thumbnail_id();
		                    $src_info = wp_get_attachment_image_src( $thumbnail_id, $size = array( 600,400 ) );
		                    $src = $src_info[0];
		                } else {
		                    $src = 'noimage.png';
		                }
		                if( $pattern_content ){
		                    $pattern_content = str_replace( array( "\r", "\n" ), '', $pattern_content );
		                    echo '<script>LPtoolsMyTemplates[1][' . $i . '] = [\'' . $pattern_title . '\', \'' . $src . '\', \'' . addslashes( $pattern_content ) . '\'];</script>';
		                    $i++;
		                }
		            }
		            echo '<script>LPtoolsTemplates.push(LPtoolsMyTemplates);</script>';
		            wp_reset_postdata();
		        }
		        
		        // Exp Templates
		        $n = 0;
		        echo '<script>var LPtoolsExpTemplate = []; LPtoolsExpTemplate[0] = [\''.$lptools_exp_templates[0][0].'\', \''.$lptools_exp_templates[0][1].'\']; LPtoolsExpTemplate[1] = [];</script>';
		        foreach( $lptools_exp_templates[1] as $lptools_exp_template ) {
			        echo '<script>LPtoolsExpTemplate[1][' . $n . '] = [\'' . $lptools_exp_template[0] . '\', \'' . $lptools_exp_template[1] . '\', \'' . addslashes( $lptools_exp_template[2] ) . '\'];</script>';
			        $n++;
		        }
		        echo '<script>LPtoolsTemplates.push(LPtoolsExpTemplate);</script>';
		        
		        // Basic Templates
		        $n = 0;
		        echo '<script>var LPtoolsBasicTemplate = []; LPtoolsBasicTemplate[0] = [\''.$lptools_basic_templates[0][0].'\', \''.$lptools_basic_templates[0][1].'\']; LPtoolsBasicTemplate[1] = [];</script>';
		        foreach( $lptools_basic_templates[1] as $lptools_basic_template ) {
			        echo '<script>LPtoolsBasicTemplate[1][' . $n . '] = [\'' . $lptools_basic_template[0] . '\', \'' . $lptools_basic_template[1] . '\', \'' . addslashes( $lptools_basic_template[2] ) . '\'];</script>';
			        $n++;
		        }
		        echo '<script>LPtoolsTemplates.push(LPtoolsBasicTemplate);</script>';
			?>
		<script>
			LPtoolsTemplatesList();
			LPtoolsTemplatesButton();
		</script>
		</div>
    </div>
</div>

<?php
	}
}
add_action( 'admin_footer', 'ctw_lptools_admin_footer' );
