'use strict';

var registerPlugin = wp.plugins.registerPlugin;
var _wp$editPost = wp.editPost,
	PluginSidebar = _wp$editPost.PluginSidebar,
	PluginSidebarMoreMenuItem = _wp$editPost.PluginSidebarMoreMenuItem;
var Fragment = wp.element.Fragment;
var _wp$components = wp.components,
	Panel = _wp$components.Panel,
	PanelBody = _wp$components.PanelBody,
	PanelRow = _wp$components.PanelRow,
	Button = _wp$components.Button,
	Spinner = _wp$components.Spinner;
var parse = wp.blocks.parse;
var _wp$richText = wp.richText,
	registerFormatType = _wp$richText.registerFormatType,
	toggleFormat = _wp$richText.toggleFormat;
var RichTextToolbarButton = wp.editor.RichTextToolbarButton;
var __ = wp.i18n.__;
var LPtoolsTemplates = [];

function LPtoolsTemplatesInsert(contents) {
	var ctw_lptools_modals = document.querySelectorAll('.ctw_lptools_modal');
	var content = wp.blocks.parse(contents);
	wp.data.dispatch('core/editor').insertBlocks(content);
	LPtoolsTemplatesClose();
}

function LPtoolsTemplatesList() {
	for (var i in LPtoolsTemplates) {
		document.write(
			'<h2 class="ctw_lptools_modal_gallery_subhead">' +
				LPtoolsTemplates[i][0][0] +
				'</h2>'
		);
		document.write('<p>' + LPtoolsTemplates[i][0][1] + '</p>');
		document.write('<ul class="ctw_lptools_modal_gallery_list">');
		for (var j in LPtoolsTemplates[i][1]) {
			var src = LPtoolsTemplates[i][1][j][1];
			var dir = src.indexOf('http') === 0 ? '' : ctw_lptools_imgurl;
			var title = LPtoolsTemplates[i][1][j][0];
			var k = Number(j) + 1;
			var list =
				'<li><a onclick="LPtoolsTemplatesInsert(LPtoolsTemplates[\'' +
				i +
				"'][1][" +
				j +
				'][2])"><div class="ctw_lptools_img"><img src="' +
				dir +
				src +
				'" alt="' +
				k +
				'" loading="lazy"></div><div class="ctw_lptools_modal_gallerry_title">' +
				title +
				'</div><div class="ctw_lptools_modal_gallerry_button components-button is-primary"><span>このテンプレートを利用</span></div></a></li>';
			document.write(list);
		}
		document.write('</ul>');
	}
}

function LPtoolsTemplatesClose() {
	var ctw_lptools_buttons = document.getElementById('ctw_lptools_buttons');
	ctw_lptools_buttons.classList.remove('ctw_lptools_modal_active');
	var ctw_lptools_modals = document.querySelectorAll('.ctw_lptools_modal');
	for (var i = 0; i < ctw_lptools_modals.length; i++) {
		ctw_lptools_modals[i].classList.remove('ctw_lptools_modal_active');
	}
	var ctw_lptools_jump = document.querySelectorAll('.ctw_lptools_jump');
	for (var _i = 0; _i < ctw_lptools_jump.length; _i++) {
		ctw_lptools_jump[_i].classList.remove('ctw_lptools_modal_active');
	}
}

function LPtoolsTemplatesButton() {
	wp.data.subscribe(function () {
		setTimeout(LPtoolsTemplatesButtonAppend, 1);
	});
}

function LPtoolsTemplatesButtonAppend() {
	wp.domReady(function () {
		setTimeout(() => {
			const header_toolbar = document.querySelector(
				'.edit-post-header-toolbar__left'
			);
			if (!header_toolbar) return;
			const ctw_lptools_button_exists = document.querySelector(
				'#ctw-lptools-button'
			);
			if (ctw_lptools_button_exists) return;

			const button_html =
				'<button type="button" aria-pressed="false" aria-expanded="false" class="components-button has-icon" aria-label="LPtools" onclick="LPtoolsTemplatesActivateModal()"><svg width="20" height="20" viewBox="0 0 24 24" class="ctw_lptools_icon" aria-hidden="true" focusable="false"><path fill="#0093D6" d="M12,0C5.37,0,0,5.37,0,12s5.37,12,12,12,12-5.37,12-12S18.63,0,12,0Zm8.42,13.14c-.23,.52-1.05,3.43-2.2,3.43-.93,0-1.25-.92-1.4-1.42h0s0,0,0-.01c-.04-.11-.1-.16-.17-.15-.07,0-.14,.05-.17,.15,0,0,0,0,0,.01h0c-.15,.5-.44,1.42-1.3,1.42s-1.14-.92-1.3-1.42h0s0,0,0-.01c-.04-.11-.1-.16-.17-.15-.07,0-.14,.05-.17,.15,0,0,0,0,0,.01h0c-.15,.5-.44,1.42-1.3,1.42s-1.14-.93-1.3-1.42c-.07-.21-.25-.22-.36,0-.25,.57-.77,1.48-2.03,1.48-2.7,0-4.9-2.2-4.9-4.9s2.2-4.9,4.9-4.9,4.9,2.2,4.9,4.9c0,.41-.33,.74-.74,.74s-.73-.33-.73-.74c0-1.89-1.54-3.43-3.43-3.43s-3.43,1.54-3.43,3.43,1.54,3.43,3.43,3.43c.5,0,.58-.15,.8-.69,.17-.42,.5-1.21,1.43-1.21,.7,0,1.07,.61,1.28,1.04l.03,.07c.04,.06,.09,.09,.14,.08,.05,0,.09-.02,.12-.06l.04-.09c.21-.43,.58-1.04,1.28-1.04h.04c.7,0,1.07,.61,1.28,1.04l.04,.08c.04,.05,.08,.08,.13,.07,.05,0,.1-.02,.13-.07l.04-.08c.21-.43,.58-1.04,1.28-1.04h.04c.69,0,1.06,.6,1.28,1.03l.04,.08s.06,.05,.1,.05c.05,0,.1-.03,.13-.11v-.02s0-.01,.01-.02c.27-1.03,1.16-2.69,2.04-2.57,.4,.05,.74,.33,.74,.74,0,.35-.25,.63-.58,.7Z"></path></svg></button>';
			header_toolbar.insertAdjacentHTML(
				'beforeend',
				'<div id="ctw-lptools-button"></div>'
			);
			var ctw_lptools_button =
				document.getElementById('ctw-lptools-button');
			const button_append = document.createElement('div');
			button_append.innerHTML = button_html;
			ctw_lptools_button.appendChild(button_append);
		}, 0);
	});
}

function LPtoolsTemplatesActivateModal() {
	document
		.getElementById('ctw_lptools_modal')
		.classList.toggle('ctw_lptools_modal_active');
	document
		.getElementById('ctw_lptools_buttons')
		.classList.toggle('ctw_lptools_modal_active');
}
